/* moonshot-password-dialog.c generated by valac 0.40.8, the Vala compiler
 * generated from moonshot-password-dialog.vala, do not modify */

/*
 * Copyright (c) 2011-2016, JANET(UK)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of JANET(UK) nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <atk/atk.h>


#define TYPE_ADD_PASSWORD_DIALOG (add_password_dialog_get_type ())
#define ADD_PASSWORD_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADD_PASSWORD_DIALOG, AddPasswordDialog))
#define ADD_PASSWORD_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ADD_PASSWORD_DIALOG, AddPasswordDialogClass))
#define IS_ADD_PASSWORD_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADD_PASSWORD_DIALOG))
#define IS_ADD_PASSWORD_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ADD_PASSWORD_DIALOG))
#define ADD_PASSWORD_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ADD_PASSWORD_DIALOG, AddPasswordDialogClass))

typedef struct _AddPasswordDialog AddPasswordDialog;
typedef struct _AddPasswordDialogClass AddPasswordDialogClass;
typedef struct _AddPasswordDialogPrivate AddPasswordDialogPrivate;
enum  {
	ADD_PASSWORD_DIALOG_0_PROPERTY,
	ADD_PASSWORD_DIALOG_PASSWORD_PROPERTY,
	ADD_PASSWORD_DIALOG_REMEMBER_PROPERTY,
	ADD_PASSWORD_DIALOG_NUM_PROPERTIES
};
static GParamSpec* add_password_dialog_properties[ADD_PASSWORD_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _AddPasswordDialog {
	GtkDialog parent_instance;
	AddPasswordDialogPrivate * priv;
};

struct _AddPasswordDialogClass {
	GtkDialogClass parent_class;
};

struct _AddPasswordDialogPrivate {
	GtkEntry* password_entry;
	GtkCheckButton* remember_checkbutton;
};


static gpointer add_password_dialog_parent_class = NULL;

GType add_password_dialog_get_type (void) G_GNUC_CONST;
#define ADD_PASSWORD_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ADD_PASSWORD_DIALOG, AddPasswordDialogPrivate))
void add_password_dialog_clear_password (AddPasswordDialog* self);
void clear_password_entry (GtkEntry* entry);
AddPasswordDialog* add_password_dialog_new (const gchar* message,
                                            gboolean show_remember);
AddPasswordDialog* add_password_dialog_construct (GType object_type,
                                                  const gchar* message,
                                                  gboolean show_remember);
void set_bg_color (GtkWidget* w);
void set_atk_relation (GtkWidget* widget,
                       GtkWidget* target_widget,
                       AtkRelationType relationship);
GtkBox* new_vbox (gint spacing);
const gchar* add_password_dialog_get_password (AddPasswordDialog* self);
gboolean add_password_dialog_get_remember (AddPasswordDialog* self);
static void add_password_dialog_finalize (GObject * obj);
static void _vala_add_password_dialog_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);


/**
     * Don't leave passwords in memory longer than necessary.
     * This may not actually erase the password data bytes, but it seems to be the best we can do.
     */
void
add_password_dialog_clear_password (AddPasswordDialog* self)
{
	GtkEntry* _tmp0_;
#line 47 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	g_return_if_fail (self != NULL);
#line 48 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp0_ = self->priv->password_entry;
#line 48 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	clear_password_entry (_tmp0_);
#line 122 "moonshot-password-dialog.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 66 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 131 "moonshot-password-dialog.c"
}


AddPasswordDialog*
add_password_dialog_construct (GType object_type,
                               const gchar* message,
                               gboolean show_remember)
{
	AddPasswordDialog * self = NULL;
	GtkBox* content_area = NULL;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkLabel* dialog_label = NULL;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* password_label = NULL;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkEntry* _tmp8_;
	GtkEntry* _tmp9_;
	GtkEntry* _tmp10_;
	GtkEntry* _tmp11_;
	GtkCheckButton* _tmp12_;
	GtkLabel* _tmp13_;
	GtkEntry* _tmp14_;
	GtkTable* table = NULL;
	GtkTable* _tmp15_;
	GtkAttachOptions opts = 0;
	gint row = 0;
	GtkTable* _tmp16_;
	GtkTable* _tmp17_;
	GtkTable* _tmp18_;
	GtkLabel* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	GtkAttachOptions _tmp22_;
	GtkAttachOptions _tmp23_;
	gint _tmp24_;
	GtkBox* password_vbox = NULL;
	GtkBox* _tmp25_;
	GtkBox* empty_box2 = NULL;
	GtkBox* _tmp26_;
	GtkBox* _tmp27_;
	GtkBox* _tmp28_;
	GtkBox* _tmp29_;
	GtkBox* _tmp30_;
	GtkLabel* _tmp31_;
	GtkBox* _tmp32_;
	GtkEntry* _tmp33_;
	GtkTable* _tmp34_;
	GtkBox* _tmp35_;
	gint _tmp36_;
	gint _tmp37_;
	GtkAttachOptions _tmp38_;
	GtkAttachOptions _tmp39_;
	gint _tmp40_;
	GtkBox* vbox = NULL;
	GtkBox* _tmp48_;
	GtkTable* _tmp49_;
	GtkBox* _tmp50_;
#line 55 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 55 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	self = (AddPasswordDialog*) g_object_new (object_type, NULL);
#line 57 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_window_set_title ((GtkWindow*) self, _ ("Moonshot - Password"));
#line 58 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 59 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	set_bg_color ((GtkWidget*) self);
#line 61 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_dialog_add_buttons ((GtkDialog*) self, _ ("Cancel"), GTK_RESPONSE_CANCEL, _ ("Connect"), GTK_RESPONSE_OK, NULL);
#line 64 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_dialog_set_default_response ((GtkDialog*) self, (gint) GTK_RESPONSE_OK);
#line 66 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp0_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 66 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 66 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	content_area = _tmp1_;
#line 67 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp2_ = content_area;
#line 67 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_box_set_spacing (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_box_get_type (), GtkBox), 12);
#line 68 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp3_ = content_area;
#line 68 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	set_bg_color ((GtkWidget*) _tmp3_);
#line 70 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new (message);
#line 70 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	g_object_ref_sink (_tmp4_);
#line 70 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	dialog_label = _tmp4_;
#line 71 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp5_ = dialog_label;
#line 71 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_misc_set_alignment ((GtkMisc*) _tmp5_, (gfloat) 0, (gfloat) 0);
#line 73 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp6_ = (GtkLabel*) gtk_label_new (_ ("Password:"));
#line 73 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	g_object_ref_sink (_tmp6_);
#line 73 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	password_label = _tmp6_;
#line 74 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp7_ = password_label;
#line 74 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_misc_set_alignment ((GtkMisc*) _tmp7_, (gfloat) 0, (gfloat) 1);
#line 75 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp8_ = (GtkEntry*) gtk_entry_new ();
#line 75 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	g_object_ref_sink (_tmp8_);
#line 75 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_g_object_unref0 (self->priv->password_entry);
#line 75 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	self->priv->password_entry = _tmp8_;
#line 76 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp9_ = self->priv->password_entry;
#line 76 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_entry_set_invisible_char (_tmp9_, (gunichar) '*');
#line 77 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp10_ = self->priv->password_entry;
#line 77 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_entry_set_visibility (_tmp10_, FALSE);
#line 78 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp11_ = self->priv->password_entry;
#line 78 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_entry_set_activates_default (_tmp11_, TRUE);
#line 79 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp12_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Remember password"));
#line 79 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	g_object_ref_sink (_tmp12_);
#line 79 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_g_object_unref0 (self->priv->remember_checkbutton);
#line 79 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	self->priv->remember_checkbutton = _tmp12_;
#line 81 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp13_ = password_label;
#line 81 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp14_ = self->priv->password_entry;
#line 81 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	set_atk_relation ((GtkWidget*) _tmp13_, (GtkWidget*) _tmp14_, ATK_RELATION_LABEL_FOR);
#line 83 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp15_ = (GtkTable*) gtk_table_new ((guint) 6, (guint) 1, FALSE);
#line 83 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	g_object_ref_sink (_tmp15_);
#line 83 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	table = _tmp15_;
#line 84 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	opts = GTK_EXPAND | GTK_FILL;
#line 85 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	row = 0;
#line 86 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp16_ = table;
#line 86 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_table_set_col_spacings (_tmp16_, (guint) 6);
#line 87 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp17_ = table;
#line 87 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_table_set_row_spacings (_tmp17_, (guint) 0);
#line 88 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp18_ = table;
#line 88 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp19_ = dialog_label;
#line 88 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp20_ = row;
#line 88 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp21_ = row;
#line 88 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp22_ = opts;
#line 88 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp23_ = opts;
#line 88 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_table_attach (_tmp18_, (GtkWidget*) _tmp19_, (guint) 0, (guint) 1, (guint) _tmp20_, (guint) (_tmp21_ + 1), _tmp22_, _tmp23_, (guint) 0, (guint) 2);
#line 89 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp24_ = row;
#line 89 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	row = _tmp24_ + 1;
#line 91 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp25_ = new_vbox (1);
#line 91 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	password_vbox = _tmp25_;
#line 92 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp26_ = new_vbox (0);
#line 92 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	empty_box2 = _tmp26_;
#line 93 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp27_ = empty_box2;
#line 93 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp27_, 0, 0);
#line 94 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp28_ = password_vbox;
#line 94 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp29_ = empty_box2;
#line 94 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_box_pack_start (_tmp28_, (GtkWidget*) _tmp29_, FALSE, FALSE, (guint) 3);
#line 95 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp30_ = password_vbox;
#line 95 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp31_ = password_label;
#line 95 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_box_pack_start (_tmp30_, (GtkWidget*) _tmp31_, FALSE, FALSE, (guint) 0);
#line 96 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp32_ = password_vbox;
#line 96 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp33_ = self->priv->password_entry;
#line 96 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_box_pack_start (_tmp32_, (GtkWidget*) _tmp33_, FALSE, FALSE, (guint) 0);
#line 97 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp34_ = table;
#line 97 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp35_ = password_vbox;
#line 97 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp36_ = row;
#line 97 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp37_ = row;
#line 97 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp38_ = opts;
#line 97 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp39_ = opts;
#line 97 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_table_attach (_tmp34_, (GtkWidget*) _tmp35_, (guint) 0, (guint) 1, (guint) _tmp36_, (guint) (_tmp37_ + 1), _tmp38_, _tmp39_, (guint) 0, (guint) 0);
#line 98 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp40_ = row;
#line 98 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	row = _tmp40_ + 1;
#line 100 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	if (show_remember) {
#line 362 "moonshot-password-dialog.c"
		GtkTable* _tmp41_;
		GtkCheckButton* _tmp42_;
		gint _tmp43_;
		gint _tmp44_;
		GtkAttachOptions _tmp45_;
		GtkAttachOptions _tmp46_;
		gint _tmp47_;
#line 101 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
		_tmp41_ = table;
#line 101 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
		_tmp42_ = self->priv->remember_checkbutton;
#line 101 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
		_tmp43_ = row;
#line 101 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
		_tmp44_ = row;
#line 101 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
		_tmp45_ = opts;
#line 101 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
		_tmp46_ = opts;
#line 101 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
		gtk_table_attach (_tmp41_, (GtkWidget*) _tmp42_, (guint) 0, (guint) 1, (guint) _tmp43_, (guint) (_tmp44_ + 1), _tmp45_, _tmp46_, (guint) 20, (guint) 2);
#line 102 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
		_tmp47_ = row;
#line 102 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
		row = _tmp47_ + 1;
#line 388 "moonshot-password-dialog.c"
	}
#line 105 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp48_ = new_vbox (0);
#line 105 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	vbox = _tmp48_;
#line 106 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_container_set_border_width ((GtkContainer*) vbox, (guint) 6);
#line 107 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp49_ = table;
#line 107 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_box_pack_start (vbox, (GtkWidget*) _tmp49_, FALSE, FALSE, (guint) 0);
#line 109 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp50_ = content_area;
#line 109 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, gtk_container_get_type (), GtkContainer), (GtkWidget*) vbox);
#line 111 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_container_set_border_width ((GtkContainer*) self, (guint) 6);
#line 113 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 55 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_g_object_unref0 (vbox);
#line 55 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_g_object_unref0 (empty_box2);
#line 55 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_g_object_unref0 (password_vbox);
#line 55 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_g_object_unref0 (table);
#line 55 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_g_object_unref0 (password_label);
#line 55 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_g_object_unref0 (dialog_label);
#line 55 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_g_object_unref0 (content_area);
#line 55 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	return self;
#line 424 "moonshot-password-dialog.c"
}


AddPasswordDialog*
add_password_dialog_new (const gchar* message,
                         gboolean show_remember)
{
#line 55 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	return add_password_dialog_construct (TYPE_ADD_PASSWORD_DIALOG, message, show_remember);
#line 434 "moonshot-password-dialog.c"
}


const gchar*
add_password_dialog_get_password (AddPasswordDialog* self)
{
	const gchar* result;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
#line 40 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp0_ = self->priv->password_entry;
#line 40 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 40 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	result = _tmp1_;
#line 40 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	return result;
#line 454 "moonshot-password-dialog.c"
}


gboolean
add_password_dialog_get_remember (AddPasswordDialog* self)
{
	gboolean result;
	GtkCheckButton* _tmp0_;
#line 52 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 52 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_tmp0_ = self->priv->remember_checkbutton;
#line 52 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	result = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 52 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	return result;
#line 471 "moonshot-password-dialog.c"
}


static void
add_password_dialog_class_init (AddPasswordDialogClass * klass)
{
#line 34 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	add_password_dialog_parent_class = g_type_class_peek_parent (klass);
#line 34 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	g_type_class_add_private (klass, sizeof (AddPasswordDialogPrivate));
#line 34 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_add_password_dialog_get_property;
#line 34 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = add_password_dialog_finalize;
#line 34 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_PASSWORD_DIALOG_PASSWORD_PROPERTY, add_password_dialog_properties[ADD_PASSWORD_DIALOG_PASSWORD_PROPERTY] = g_param_spec_string ("password", "password", "password", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 34 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_PASSWORD_DIALOG_REMEMBER_PROPERTY, add_password_dialog_properties[ADD_PASSWORD_DIALOG_REMEMBER_PROPERTY] = g_param_spec_boolean ("remember", "remember", "remember", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 490 "moonshot-password-dialog.c"
}


static void
add_password_dialog_instance_init (AddPasswordDialog * self)
{
#line 34 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	self->priv = ADD_PASSWORD_DIALOG_GET_PRIVATE (self);
#line 499 "moonshot-password-dialog.c"
}


static void
add_password_dialog_finalize (GObject * obj)
{
	AddPasswordDialog * self;
#line 34 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ADD_PASSWORD_DIALOG, AddPasswordDialog);
#line 36 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_g_object_unref0 (self->priv->password_entry);
#line 37 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	_g_object_unref0 (self->priv->remember_checkbutton);
#line 34 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	G_OBJECT_CLASS (add_password_dialog_parent_class)->finalize (obj);
#line 515 "moonshot-password-dialog.c"
}


GType
add_password_dialog_get_type (void)
{
	static volatile gsize add_password_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&add_password_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AddPasswordDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) add_password_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AddPasswordDialog), 0, (GInstanceInitFunc) add_password_dialog_instance_init, NULL };
		GType add_password_dialog_type_id;
		add_password_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "AddPasswordDialog", &g_define_type_info, 0);
		g_once_init_leave (&add_password_dialog_type_id__volatile, add_password_dialog_type_id);
	}
	return add_password_dialog_type_id__volatile;
}


static void
_vala_add_password_dialog_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	AddPasswordDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ADD_PASSWORD_DIALOG, AddPasswordDialog);
#line 34 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
	switch (property_id) {
#line 34 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
		case ADD_PASSWORD_DIALOG_PASSWORD_PROPERTY:
#line 34 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
		g_value_set_string (value, add_password_dialog_get_password (self));
#line 34 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
		break;
#line 34 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
		case ADD_PASSWORD_DIALOG_REMEMBER_PROPERTY:
#line 34 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
		g_value_set_boolean (value, add_password_dialog_get_remember (self));
#line 34 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
		break;
#line 555 "moonshot-password-dialog.c"
		default:
#line 34 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "/builds/moonshot/ui/src/moonshot-password-dialog.vala"
		break;
#line 561 "moonshot-password-dialog.c"
	}
}



