/* moonshot-settings.c generated by valac 0.40.8, the Vala compiler
 * generated from moonshot-settings.vala, do not modify */

/*
 * Copyright (c) 2011-2016, JANET(UK)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of JANET(UK) nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define TYPE_MOONSHOT_LOGGER (moonshot_logger_get_type ())
#define MOONSHOT_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MOONSHOT_LOGGER, MoonshotLogger))
#define MOONSHOT_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MOONSHOT_LOGGER, MoonshotLoggerClass))
#define IS_MOONSHOT_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MOONSHOT_LOGGER))
#define IS_MOONSHOT_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MOONSHOT_LOGGER))
#define MOONSHOT_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MOONSHOT_LOGGER, MoonshotLoggerClass))

typedef struct _MoonshotLogger MoonshotLogger;
typedef struct _MoonshotLoggerClass MoonshotLoggerClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



GType moonshot_logger_get_type (void) G_GNUC_CONST;
MoonshotLogger* logger (void);
MoonshotLogger* get_logger (const gchar* name);
#define KEY_FILE_NAME "moonshot-ui.config"
GKeyFile* get_keyfile (void);
void moonshot_logger_trace (MoonshotLogger* self,
                            const gchar* message,
                            GError* e);
void save_keyfile (GKeyFile* key_file);
void moonshot_logger_error (MoonshotLogger* self,
                            const gchar* message,
                            GError* e);
void set_bool_setting (const gchar* group_name,
                       const gchar* key_name,
                       gboolean value,
                       GKeyFile* key_file);
gboolean get_bool_setting (const gchar* group_name,
                           const gchar* key_name,
                           gboolean _default_,
                           GKeyFile* key_file);
void moonshot_logger_info (MoonshotLogger* self,
                           const gchar* message,
                           GError* e);
gchar* get_string_setting (const gchar* group_name,
                           const gchar* key_name,
                           const gchar* _default_,
                           GKeyFile* key_file);
void set_string_setting (const gchar* group_name,
                         const gchar* key_name,
                         const gchar* value,
                         GKeyFile* key_file);


MoonshotLogger*
logger (void)
{
	MoonshotLogger* result = NULL;
	MoonshotLogger* _tmp0_;
#line 38 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp0_ = get_logger ("MoonshotSettings");
#line 38 "/builds/moonshot/ui/src/moonshot-settings.vala"
	result = _tmp0_;
#line 38 "/builds/moonshot/ui/src/moonshot-settings.vala"
	return result;
#line 105 "moonshot-settings.c"
}


GKeyFile*
get_keyfile (void)
{
	GKeyFile* result = NULL;
	GKeyFile* key_file = NULL;
	GKeyFile* _tmp0_;
	gchar* config_dir = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	MoonshotLogger* _tmp3_;
	MoonshotLogger* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GFile* dir = NULL;
	const gchar* _tmp8_;
	GFile* _tmp9_;
	gchar* path = NULL;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GError * _inner_error_ = NULL;
#line 45 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp0_ = g_key_file_new ();
#line 45 "/builds/moonshot/ui/src/moonshot-settings.vala"
	key_file = _tmp0_;
#line 46 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp1_ = g_get_user_config_dir ();
#line 46 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 46 "/builds/moonshot/ui/src/moonshot-settings.vala"
	config_dir = _tmp2_;
#line 47 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp3_ = logger ();
#line 47 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp4_ = _tmp3_;
#line 47 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp5_ = config_dir;
#line 47 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp6_ = g_strconcat ("get_keyfile: config_dir=", _tmp5_, NULL);
#line 47 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp7_ = _tmp6_;
#line 47 "/builds/moonshot/ui/src/moonshot-settings.vala"
	moonshot_logger_trace (_tmp4_, _tmp7_, NULL);
#line 47 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_g_free0 (_tmp7_);
#line 47 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_g_object_unref0 (_tmp4_);
#line 49 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp8_ = config_dir;
#line 49 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp9_ = g_file_new_for_path (_tmp8_);
#line 49 "/builds/moonshot/ui/src/moonshot-settings.vala"
	dir = _tmp9_;
#line 50 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp10_ = dir;
#line 50 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp11_ = g_file_get_child (_tmp10_, KEY_FILE_NAME);
#line 50 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp12_ = _tmp11_;
#line 50 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp13_ = g_file_get_path (_tmp12_);
#line 50 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp14_ = _tmp13_;
#line 50 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_g_object_unref0 (_tmp12_);
#line 50 "/builds/moonshot/ui/src/moonshot-settings.vala"
	path = _tmp14_;
#line 179 "moonshot-settings.c"
	{
		gboolean _tmp15_ = FALSE;
		GKeyFile* _tmp16_;
		const gchar* _tmp17_;
#line 53 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp16_ = key_file;
#line 53 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp17_ = path;
#line 53 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp15_ = g_key_file_load_from_file (_tmp16_, _tmp17_, G_KEY_FILE_NONE, &_inner_error_);
#line 53 "/builds/moonshot/ui/src/moonshot-settings.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 53 "/builds/moonshot/ui/src/moonshot-settings.vala"
			if (_inner_error_->domain == G_FILE_ERROR) {
#line 194 "moonshot-settings.c"
				goto __catch20_g_file_error;
			}
#line 53 "/builds/moonshot/ui/src/moonshot-settings.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 199 "moonshot-settings.c"
				goto __catch20_g_key_file_error;
			}
#line 53 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_g_free0 (path);
#line 53 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_g_object_unref0 (dir);
#line 53 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_g_free0 (config_dir);
#line 53 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_g_key_file_unref0 (key_file);
#line 53 "/builds/moonshot/ui/src/moonshot-settings.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 53 "/builds/moonshot/ui/src/moonshot-settings.vala"
			g_clear_error (&_inner_error_);
#line 53 "/builds/moonshot/ui/src/moonshot-settings.vala"
			return NULL;
#line 216 "moonshot-settings.c"
		}
#line 53 "/builds/moonshot/ui/src/moonshot-settings.vala"
		if (_tmp15_) {
#line 220 "moonshot-settings.c"
			MoonshotLogger* _tmp18_;
			MoonshotLogger* _tmp19_;
#line 54 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_tmp18_ = logger ();
#line 54 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_tmp19_ = _tmp18_;
#line 54 "/builds/moonshot/ui/src/moonshot-settings.vala"
			moonshot_logger_trace (_tmp19_, "get_keyfile: load_from_file returned successfully", NULL);
#line 54 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_g_object_unref0 (_tmp19_);
#line 231 "moonshot-settings.c"
		} else {
			MoonshotLogger* _tmp20_;
			MoonshotLogger* _tmp21_;
#line 56 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_tmp20_ = logger ();
#line 56 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_tmp21_ = _tmp20_;
#line 56 "/builds/moonshot/ui/src/moonshot-settings.vala"
			moonshot_logger_trace (_tmp21_, "get_keyfile: load_from_file returned false", NULL);
#line 56 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_g_object_unref0 (_tmp21_);
#line 243 "moonshot-settings.c"
		}
	}
	goto __finally20;
	__catch20_g_file_error:
	{
		GError* e = NULL;
		MoonshotLogger* _tmp22_;
		MoonshotLogger* _tmp23_;
		GError* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
#line 52 "/builds/moonshot/ui/src/moonshot-settings.vala"
		e = _inner_error_;
#line 52 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_inner_error_ = NULL;
#line 59 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp22_ = logger ();
#line 59 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp23_ = _tmp22_;
#line 59 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp24_ = e;
#line 59 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp25_ = _tmp24_->message;
#line 59 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp26_ = g_strconcat ("get_keyfile: FileError: ", _tmp25_, NULL);
#line 59 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp27_ = _tmp26_;
#line 59 "/builds/moonshot/ui/src/moonshot-settings.vala"
		moonshot_logger_trace (_tmp23_, _tmp27_, NULL);
#line 59 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (_tmp27_);
#line 59 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_object_unref0 (_tmp23_);
#line 52 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_error_free0 (e);
#line 280 "moonshot-settings.c"
	}
	goto __finally20;
	__catch20_g_key_file_error:
	{
		GError* e = NULL;
		MoonshotLogger* _tmp28_;
		MoonshotLogger* _tmp29_;
		GError* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
#line 52 "/builds/moonshot/ui/src/moonshot-settings.vala"
		e = _inner_error_;
#line 52 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_inner_error_ = NULL;
#line 62 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp28_ = logger ();
#line 62 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp29_ = _tmp28_;
#line 62 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp30_ = e;
#line 62 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp31_ = _tmp30_->message;
#line 62 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp32_ = g_strconcat ("get_keyfile: KeyFileError: ", _tmp31_, NULL);
#line 62 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp33_ = _tmp32_;
#line 62 "/builds/moonshot/ui/src/moonshot-settings.vala"
		moonshot_logger_trace (_tmp29_, _tmp33_, NULL);
#line 62 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (_tmp33_);
#line 62 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_object_unref0 (_tmp29_);
#line 52 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_error_free0 (e);
#line 316 "moonshot-settings.c"
	}
	__finally20:
#line 52 "/builds/moonshot/ui/src/moonshot-settings.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 52 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (path);
#line 52 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_object_unref0 (dir);
#line 52 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (config_dir);
#line 52 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_key_file_unref0 (key_file);
#line 52 "/builds/moonshot/ui/src/moonshot-settings.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 52 "/builds/moonshot/ui/src/moonshot-settings.vala"
		g_clear_error (&_inner_error_);
#line 52 "/builds/moonshot/ui/src/moonshot-settings.vala"
		return NULL;
#line 335 "moonshot-settings.c"
	}
#line 65 "/builds/moonshot/ui/src/moonshot-settings.vala"
	result = key_file;
#line 65 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_g_free0 (path);
#line 65 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_g_object_unref0 (dir);
#line 65 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_g_free0 (config_dir);
#line 65 "/builds/moonshot/ui/src/moonshot-settings.vala"
	return result;
#line 347 "moonshot-settings.c"
}


static guint8*
string_get_data (const gchar* self,
                 int* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
#line 1442 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1443 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	res = (guint8*) self;
#line 1443 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	res_length1 = -1;
#line 1443 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1444 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1444 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1444 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1444 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp2_ = res_length1;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp3_ = res;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp3__length1 = res_length1;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp4__length1 = _tmp3__length1;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (result_length1) {
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 394 "moonshot-settings.c"
	}
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 400 "moonshot-settings.c"
}


void
save_keyfile (GKeyFile* key_file)
{
	gchar* config_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* dest = NULL;
	gchar* data = NULL;
	gchar* _tmp10_;
	GError * _inner_error_ = NULL;
#line 69 "/builds/moonshot/ui/src/moonshot-settings.vala"
	g_return_if_fail (key_file != NULL);
#line 71 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp0_ = g_get_user_config_dir ();
#line 71 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 71 "/builds/moonshot/ui/src/moonshot-settings.vala"
	config_dir = _tmp1_;
#line 72 "/builds/moonshot/ui/src/moonshot-settings.vala"
	dest = NULL;
#line 424 "moonshot-settings.c"
	{
		GFile* dir = NULL;
		GFile* _tmp2_;
		GFile* _tmp3_;
#line 76 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp2_ = g_file_new_for_path (config_dir);
#line 76 "/builds/moonshot/ui/src/moonshot-settings.vala"
		dir = _tmp2_;
#line 77 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp3_ = g_file_get_child (dir, KEY_FILE_NAME);
#line 77 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_object_unref0 (dest);
#line 77 "/builds/moonshot/ui/src/moonshot-settings.vala"
		dest = _tmp3_;
#line 78 "/builds/moonshot/ui/src/moonshot-settings.vala"
		g_file_make_directory_with_parents (dir, NULL, &_inner_error_);
#line 78 "/builds/moonshot/ui/src/moonshot-settings.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 78 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_g_object_unref0 (dir);
#line 445 "moonshot-settings.c"
			goto __catch21_g_error;
		}
#line 75 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_object_unref0 (dir);
#line 450 "moonshot-settings.c"
	}
	goto __finally21;
	__catch21_g_error:
	{
		GError* e = NULL;
		MoonshotLogger* _tmp4_;
		MoonshotLogger* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 75 "/builds/moonshot/ui/src/moonshot-settings.vala"
		e = _inner_error_;
#line 75 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_inner_error_ = NULL;
#line 80 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp4_ = logger ();
#line 80 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp5_ = _tmp4_;
#line 80 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp6_ = e;
#line 80 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp7_ = _tmp6_->message;
#line 80 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp8_ = g_strconcat ("save_keyfile: make_directory_with_parents threw error (this is usually" \
" ignorable) : ", _tmp7_, NULL);
#line 80 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp9_ = _tmp8_;
#line 80 "/builds/moonshot/ui/src/moonshot-settings.vala"
		moonshot_logger_trace (_tmp5_, _tmp9_, NULL);
#line 80 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (_tmp9_);
#line 80 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_object_unref0 (_tmp5_);
#line 75 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_error_free0 (e);
#line 486 "moonshot-settings.c"
	}
	__finally21:
#line 75 "/builds/moonshot/ui/src/moonshot-settings.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 75 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_object_unref0 (dest);
#line 75 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (config_dir);
#line 75 "/builds/moonshot/ui/src/moonshot-settings.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 75 "/builds/moonshot/ui/src/moonshot-settings.vala"
		g_clear_error (&_inner_error_);
#line 75 "/builds/moonshot/ui/src/moonshot-settings.vala"
		return;
#line 501 "moonshot-settings.c"
	}
#line 87 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp10_ = g_key_file_to_data (key_file, NULL, NULL);
#line 87 "/builds/moonshot/ui/src/moonshot-settings.vala"
	data = _tmp10_;
#line 507 "moonshot-settings.c"
	{
		MoonshotLogger* _tmp11_;
		MoonshotLogger* _tmp12_;
		GFile* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* new_etag = NULL;
		GFile* _tmp18_;
		guint8* _tmp19_;
		gint _tmp19__length1;
		guint8* _tmp20_;
		gint _tmp20__length1;
		gchar* _tmp21_ = NULL;
#line 89 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp11_ = logger ();
#line 89 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp12_ = _tmp11_;
#line 89 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp13_ = dest;
#line 89 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp14_ = g_file_get_path (_tmp13_);
#line 89 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp15_ = _tmp14_;
#line 89 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp16_ = g_strdup_printf ("save_keyfile: saving to file path '%s'", _tmp15_);
#line 89 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp17_ = _tmp16_;
#line 89 "/builds/moonshot/ui/src/moonshot-settings.vala"
		moonshot_logger_trace (_tmp12_, _tmp17_, NULL);
#line 89 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (_tmp17_);
#line 89 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (_tmp15_);
#line 89 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_object_unref0 (_tmp12_);
#line 95 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp18_ = dest;
#line 95 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp19_ = string_get_data (data, &_tmp19__length1);
#line 95 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp20_ = _tmp19_;
#line 95 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp20__length1 = _tmp19__length1;
#line 95 "/builds/moonshot/ui/src/moonshot-settings.vala"
		g_file_replace_contents (_tmp18_, _tmp20_, (gsize) _tmp20__length1, NULL, FALSE, G_FILE_CREATE_REPLACE_DESTINATION | G_FILE_CREATE_PRIVATE, &_tmp21_, NULL, &_inner_error_);
#line 95 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (new_etag);
#line 95 "/builds/moonshot/ui/src/moonshot-settings.vala"
		new_etag = _tmp21_;
#line 95 "/builds/moonshot/ui/src/moonshot-settings.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 95 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_g_free0 (new_etag);
#line 563 "moonshot-settings.c"
			goto __catch22_g_error;
		}
#line 88 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (new_etag);
#line 568 "moonshot-settings.c"
	}
	goto __finally22;
	__catch22_g_error:
	{
		GError* e = NULL;
		MoonshotLogger* _tmp22_;
		MoonshotLogger* _tmp23_;
		GError* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
#line 88 "/builds/moonshot/ui/src/moonshot-settings.vala"
		e = _inner_error_;
#line 88 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_inner_error_ = NULL;
#line 101 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp22_ = logger ();
#line 101 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp23_ = _tmp22_;
#line 101 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp24_ = e;
#line 101 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp25_ = _tmp24_->message;
#line 101 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp26_ = g_strconcat ("save_keyfile: error when writing to file: ", _tmp25_, NULL);
#line 101 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp27_ = _tmp26_;
#line 101 "/builds/moonshot/ui/src/moonshot-settings.vala"
		moonshot_logger_error (_tmp23_, _tmp27_, NULL);
#line 101 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (_tmp27_);
#line 101 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_object_unref0 (_tmp23_);
#line 88 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_error_free0 (e);
#line 604 "moonshot-settings.c"
	}
	__finally22:
#line 88 "/builds/moonshot/ui/src/moonshot-settings.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 88 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (data);
#line 88 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_object_unref0 (dest);
#line 88 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (config_dir);
#line 88 "/builds/moonshot/ui/src/moonshot-settings.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 88 "/builds/moonshot/ui/src/moonshot-settings.vala"
		g_clear_error (&_inner_error_);
#line 88 "/builds/moonshot/ui/src/moonshot-settings.vala"
		return;
#line 621 "moonshot-settings.c"
	}
#line 69 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_g_free0 (data);
#line 69 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_g_object_unref0 (dest);
#line 69 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_g_free0 (config_dir);
#line 629 "moonshot-settings.c"
}


void
set_bool_setting (const gchar* group_name,
                  const gchar* key_name,
                  gboolean value,
                  GKeyFile* key_file)
{
	GKeyFile* tmp_key_file = NULL;
	GKeyFile* _tmp2_;
#line 107 "/builds/moonshot/ui/src/moonshot-settings.vala"
	g_return_if_fail (group_name != NULL);
#line 107 "/builds/moonshot/ui/src/moonshot-settings.vala"
	g_return_if_fail (key_name != NULL);
#line 109 "/builds/moonshot/ui/src/moonshot-settings.vala"
	tmp_key_file = NULL;
#line 110 "/builds/moonshot/ui/src/moonshot-settings.vala"
	if (key_file == NULL) {
#line 649 "moonshot-settings.c"
		GKeyFile* _tmp0_;
		GKeyFile* _tmp1_;
#line 112 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp0_ = get_keyfile ();
#line 112 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_key_file_unref0 (tmp_key_file);
#line 112 "/builds/moonshot/ui/src/moonshot-settings.vala"
		tmp_key_file = _tmp0_;
#line 113 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp1_ = tmp_key_file;
#line 113 "/builds/moonshot/ui/src/moonshot-settings.vala"
		key_file = _tmp1_;
#line 662 "moonshot-settings.c"
	}
#line 116 "/builds/moonshot/ui/src/moonshot-settings.vala"
	g_key_file_set_boolean (key_file, group_name, key_name, value);
#line 118 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp2_ = tmp_key_file;
#line 118 "/builds/moonshot/ui/src/moonshot-settings.vala"
	if (_tmp2_ != NULL) {
#line 120 "/builds/moonshot/ui/src/moonshot-settings.vala"
		save_keyfile (key_file);
#line 672 "moonshot-settings.c"
	}
#line 107 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_g_key_file_unref0 (tmp_key_file);
#line 676 "moonshot-settings.c"
}


static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1456 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1457 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = self;
#line 1457 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 690 "moonshot-settings.c"
}


gboolean
get_bool_setting (const gchar* group_name,
                  const gchar* key_name,
                  gboolean _default_,
                  GKeyFile* key_file)
{
	gboolean result = FALSE;
	GKeyFile* tmp_key_file = NULL;
	GError * _inner_error_ = NULL;
#line 124 "/builds/moonshot/ui/src/moonshot-settings.vala"
	g_return_val_if_fail (group_name != NULL, FALSE);
#line 124 "/builds/moonshot/ui/src/moonshot-settings.vala"
	g_return_val_if_fail (key_name != NULL, FALSE);
#line 126 "/builds/moonshot/ui/src/moonshot-settings.vala"
	tmp_key_file = NULL;
#line 127 "/builds/moonshot/ui/src/moonshot-settings.vala"
	if (key_file == NULL) {
#line 711 "moonshot-settings.c"
		GKeyFile* _tmp0_;
		GKeyFile* _tmp1_;
#line 129 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp0_ = get_keyfile ();
#line 129 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_key_file_unref0 (tmp_key_file);
#line 129 "/builds/moonshot/ui/src/moonshot-settings.vala"
		tmp_key_file = _tmp0_;
#line 130 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp1_ = tmp_key_file;
#line 130 "/builds/moonshot/ui/src/moonshot-settings.vala"
		key_file = _tmp1_;
#line 724 "moonshot-settings.c"
	}
#line 133 "/builds/moonshot/ui/src/moonshot-settings.vala"
	if (key_file == NULL) {
#line 134 "/builds/moonshot/ui/src/moonshot-settings.vala"
		result = _default_;
#line 134 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_key_file_unref0 (tmp_key_file);
#line 134 "/builds/moonshot/ui/src/moonshot-settings.vala"
		return result;
#line 734 "moonshot-settings.c"
	}
	{
		gboolean _tmp2_ = FALSE;
#line 137 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp2_ = g_key_file_has_key (key_file, group_name, key_name, &_inner_error_);
#line 137 "/builds/moonshot/ui/src/moonshot-settings.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 742 "moonshot-settings.c"
			gboolean _tmp3_ = FALSE;
#line 137 "/builds/moonshot/ui/src/moonshot-settings.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 746 "moonshot-settings.c"
				goto __catch23_g_key_file_error;
			}
#line 137 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_g_key_file_unref0 (tmp_key_file);
#line 137 "/builds/moonshot/ui/src/moonshot-settings.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 137 "/builds/moonshot/ui/src/moonshot-settings.vala"
			g_clear_error (&_inner_error_);
#line 137 "/builds/moonshot/ui/src/moonshot-settings.vala"
			return _tmp3_;
#line 757 "moonshot-settings.c"
		}
#line 137 "/builds/moonshot/ui/src/moonshot-settings.vala"
		if (!_tmp2_) {
#line 761 "moonshot-settings.c"
			MoonshotLogger* _tmp4_;
			MoonshotLogger* _tmp5_;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 139 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_tmp4_ = logger ();
#line 139 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_tmp5_ = _tmp4_;
#line 139 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_tmp6_ = string_to_string (key_name);
#line 139 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_tmp7_ = string_to_string (group_name);
#line 139 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_tmp8_ = g_strconcat ("get_bool_setting : key file doesn't contain key '", _tmp6_, "' in group '", _tmp7_, "'", NULL);
#line 139 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_tmp9_ = _tmp8_;
#line 139 "/builds/moonshot/ui/src/moonshot-settings.vala"
			moonshot_logger_info (_tmp5_, _tmp9_, NULL);
#line 139 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_g_free0 (_tmp9_);
#line 139 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_g_object_unref0 (_tmp5_);
#line 140 "/builds/moonshot/ui/src/moonshot-settings.vala"
			result = _default_;
#line 140 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_g_key_file_unref0 (tmp_key_file);
#line 140 "/builds/moonshot/ui/src/moonshot-settings.vala"
			return result;
#line 792 "moonshot-settings.c"
		}
	}
	goto __finally23;
	__catch23_g_key_file_error:
	{
		GError* e = NULL;
		MoonshotLogger* _tmp10_;
		MoonshotLogger* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GError* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 136 "/builds/moonshot/ui/src/moonshot-settings.vala"
		e = _inner_error_;
#line 136 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_inner_error_ = NULL;
#line 144 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp10_ = logger ();
#line 144 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp11_ = _tmp10_;
#line 144 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp12_ = string_to_string (key_name);
#line 144 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp13_ = string_to_string (group_name);
#line 144 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp14_ = g_strconcat ("get_bool_setting : KeyFileError checking if key '", _tmp12_, "' exists in group '", _tmp13_, "' (maybe ignorable?) : ", NULL);
#line 144 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp15_ = _tmp14_;
#line 144 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp16_ = e;
#line 144 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp17_ = _tmp16_->message;
#line 144 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp18_ = g_strconcat (_tmp15_, _tmp17_, NULL);
#line 144 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp19_ = _tmp18_;
#line 144 "/builds/moonshot/ui/src/moonshot-settings.vala"
		moonshot_logger_info (_tmp11_, _tmp19_, NULL);
#line 144 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (_tmp19_);
#line 144 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (_tmp15_);
#line 144 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_object_unref0 (_tmp11_);
#line 136 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_error_free0 (e);
#line 843 "moonshot-settings.c"
	}
	__finally23:
#line 136 "/builds/moonshot/ui/src/moonshot-settings.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 848 "moonshot-settings.c"
		gboolean _tmp20_ = FALSE;
#line 136 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_key_file_unref0 (tmp_key_file);
#line 136 "/builds/moonshot/ui/src/moonshot-settings.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 136 "/builds/moonshot/ui/src/moonshot-settings.vala"
		g_clear_error (&_inner_error_);
#line 136 "/builds/moonshot/ui/src/moonshot-settings.vala"
		return _tmp20_;
#line 858 "moonshot-settings.c"
	}
	{
		gboolean _tmp21_ = FALSE;
#line 149 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp21_ = g_key_file_get_boolean (key_file, group_name, key_name, &_inner_error_);
#line 149 "/builds/moonshot/ui/src/moonshot-settings.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 866 "moonshot-settings.c"
			gboolean _tmp22_ = FALSE;
#line 149 "/builds/moonshot/ui/src/moonshot-settings.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 870 "moonshot-settings.c"
				goto __catch24_g_key_file_error;
			}
#line 149 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_g_key_file_unref0 (tmp_key_file);
#line 149 "/builds/moonshot/ui/src/moonshot-settings.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 149 "/builds/moonshot/ui/src/moonshot-settings.vala"
			g_clear_error (&_inner_error_);
#line 149 "/builds/moonshot/ui/src/moonshot-settings.vala"
			return _tmp22_;
#line 881 "moonshot-settings.c"
		}
#line 149 "/builds/moonshot/ui/src/moonshot-settings.vala"
		result = _tmp21_;
#line 149 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_key_file_unref0 (tmp_key_file);
#line 149 "/builds/moonshot/ui/src/moonshot-settings.vala"
		return result;
#line 889 "moonshot-settings.c"
	}
	goto __finally24;
	__catch24_g_key_file_error:
	{
		GError* e = NULL;
		MoonshotLogger* _tmp23_;
		MoonshotLogger* _tmp24_;
		GError* _tmp25_;
		const gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
#line 147 "/builds/moonshot/ui/src/moonshot-settings.vala"
		e = _inner_error_;
#line 147 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_inner_error_ = NULL;
#line 152 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp23_ = logger ();
#line 152 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp24_ = _tmp23_;
#line 152 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp25_ = e;
#line 152 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp26_ = _tmp25_->message;
#line 152 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp27_ = g_strconcat ("get_bool_setting got KeyFileError (may be ignorable) : ", _tmp26_, NULL);
#line 152 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp28_ = _tmp27_;
#line 152 "/builds/moonshot/ui/src/moonshot-settings.vala"
		moonshot_logger_info (_tmp24_, _tmp28_, NULL);
#line 152 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (_tmp28_);
#line 152 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_object_unref0 (_tmp24_);
#line 147 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_error_free0 (e);
#line 925 "moonshot-settings.c"
	}
	__finally24:
#line 147 "/builds/moonshot/ui/src/moonshot-settings.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 930 "moonshot-settings.c"
		gboolean _tmp29_ = FALSE;
#line 147 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_key_file_unref0 (tmp_key_file);
#line 147 "/builds/moonshot/ui/src/moonshot-settings.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 147 "/builds/moonshot/ui/src/moonshot-settings.vala"
		g_clear_error (&_inner_error_);
#line 147 "/builds/moonshot/ui/src/moonshot-settings.vala"
		return _tmp29_;
#line 940 "moonshot-settings.c"
	}
#line 154 "/builds/moonshot/ui/src/moonshot-settings.vala"
	result = _default_;
#line 154 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_g_key_file_unref0 (tmp_key_file);
#line 154 "/builds/moonshot/ui/src/moonshot-settings.vala"
	return result;
#line 948 "moonshot-settings.c"
}


gchar*
get_string_setting (const gchar* group_name,
                    const gchar* key_name,
                    const gchar* _default_,
                    GKeyFile* key_file)
{
	gchar* result = NULL;
	GKeyFile* tmp_key_file = NULL;
	gchar* _tmp30_;
	GError * _inner_error_ = NULL;
#line 157 "/builds/moonshot/ui/src/moonshot-settings.vala"
	g_return_val_if_fail (group_name != NULL, NULL);
#line 157 "/builds/moonshot/ui/src/moonshot-settings.vala"
	g_return_val_if_fail (key_name != NULL, NULL);
#line 157 "/builds/moonshot/ui/src/moonshot-settings.vala"
	g_return_val_if_fail (_default_ != NULL, NULL);
#line 159 "/builds/moonshot/ui/src/moonshot-settings.vala"
	tmp_key_file = NULL;
#line 160 "/builds/moonshot/ui/src/moonshot-settings.vala"
	if (key_file == NULL) {
#line 972 "moonshot-settings.c"
		GKeyFile* _tmp0_;
		GKeyFile* _tmp1_;
#line 162 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp0_ = get_keyfile ();
#line 162 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_key_file_unref0 (tmp_key_file);
#line 162 "/builds/moonshot/ui/src/moonshot-settings.vala"
		tmp_key_file = _tmp0_;
#line 163 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp1_ = tmp_key_file;
#line 163 "/builds/moonshot/ui/src/moonshot-settings.vala"
		key_file = _tmp1_;
#line 985 "moonshot-settings.c"
	}
#line 166 "/builds/moonshot/ui/src/moonshot-settings.vala"
	if (key_file == NULL) {
#line 989 "moonshot-settings.c"
		gchar* _tmp2_;
#line 167 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp2_ = g_strdup (_default_);
#line 167 "/builds/moonshot/ui/src/moonshot-settings.vala"
		result = _tmp2_;
#line 167 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_key_file_unref0 (tmp_key_file);
#line 167 "/builds/moonshot/ui/src/moonshot-settings.vala"
		return result;
#line 999 "moonshot-settings.c"
	}
	{
		gboolean _tmp3_ = FALSE;
#line 170 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp3_ = g_key_file_has_key (key_file, group_name, key_name, &_inner_error_);
#line 170 "/builds/moonshot/ui/src/moonshot-settings.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 170 "/builds/moonshot/ui/src/moonshot-settings.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1009 "moonshot-settings.c"
				goto __catch25_g_key_file_error;
			}
#line 170 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_g_key_file_unref0 (tmp_key_file);
#line 170 "/builds/moonshot/ui/src/moonshot-settings.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 170 "/builds/moonshot/ui/src/moonshot-settings.vala"
			g_clear_error (&_inner_error_);
#line 170 "/builds/moonshot/ui/src/moonshot-settings.vala"
			return NULL;
#line 1020 "moonshot-settings.c"
		}
#line 170 "/builds/moonshot/ui/src/moonshot-settings.vala"
		if (!_tmp3_) {
#line 1024 "moonshot-settings.c"
			MoonshotLogger* _tmp4_;
			MoonshotLogger* _tmp5_;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 172 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_tmp4_ = logger ();
#line 172 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_tmp5_ = _tmp4_;
#line 172 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_tmp6_ = string_to_string (key_name);
#line 172 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_tmp7_ = string_to_string (group_name);
#line 172 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_tmp8_ = g_strconcat ("get_string_setting : key file doesn't contain key '", _tmp6_, "' in group '", _tmp7_, "'", NULL);
#line 172 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_tmp9_ = _tmp8_;
#line 172 "/builds/moonshot/ui/src/moonshot-settings.vala"
			moonshot_logger_info (_tmp5_, _tmp9_, NULL);
#line 172 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_g_free0 (_tmp9_);
#line 172 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_g_object_unref0 (_tmp5_);
#line 173 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_tmp10_ = g_strdup (_default_);
#line 173 "/builds/moonshot/ui/src/moonshot-settings.vala"
			result = _tmp10_;
#line 173 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_g_key_file_unref0 (tmp_key_file);
#line 173 "/builds/moonshot/ui/src/moonshot-settings.vala"
			return result;
#line 1058 "moonshot-settings.c"
		}
	}
	goto __finally25;
	__catch25_g_key_file_error:
	{
		GError* e = NULL;
		MoonshotLogger* _tmp11_;
		MoonshotLogger* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 169 "/builds/moonshot/ui/src/moonshot-settings.vala"
		e = _inner_error_;
#line 169 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_inner_error_ = NULL;
#line 177 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp11_ = logger ();
#line 177 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp12_ = _tmp11_;
#line 177 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp13_ = string_to_string (key_name);
#line 177 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp14_ = string_to_string (group_name);
#line 177 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp15_ = g_strconcat ("get_string_setting : KeyFileError checking if key '", _tmp13_, "' exists in group '", _tmp14_, "' (maybe ignorable?) : ", NULL);
#line 177 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp16_ = _tmp15_;
#line 177 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp17_ = e;
#line 177 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp18_ = _tmp17_->message;
#line 177 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp19_ = g_strconcat (_tmp16_, _tmp18_, NULL);
#line 177 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp20_ = _tmp19_;
#line 177 "/builds/moonshot/ui/src/moonshot-settings.vala"
		moonshot_logger_info (_tmp12_, _tmp20_, NULL);
#line 177 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (_tmp20_);
#line 177 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (_tmp16_);
#line 177 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_object_unref0 (_tmp12_);
#line 169 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_error_free0 (e);
#line 1109 "moonshot-settings.c"
	}
	__finally25:
#line 169 "/builds/moonshot/ui/src/moonshot-settings.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 169 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_key_file_unref0 (tmp_key_file);
#line 169 "/builds/moonshot/ui/src/moonshot-settings.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 169 "/builds/moonshot/ui/src/moonshot-settings.vala"
		g_clear_error (&_inner_error_);
#line 169 "/builds/moonshot/ui/src/moonshot-settings.vala"
		return NULL;
#line 1122 "moonshot-settings.c"
	}
	{
		gchar* _tmp21_ = NULL;
		gchar* _tmp22_;
		gchar* _tmp23_;
#line 182 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp22_ = g_key_file_get_string (key_file, group_name, key_name, &_inner_error_);
#line 182 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp21_ = _tmp22_;
#line 182 "/builds/moonshot/ui/src/moonshot-settings.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 182 "/builds/moonshot/ui/src/moonshot-settings.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1136 "moonshot-settings.c"
				goto __catch26_g_key_file_error;
			}
#line 182 "/builds/moonshot/ui/src/moonshot-settings.vala"
			_g_key_file_unref0 (tmp_key_file);
#line 182 "/builds/moonshot/ui/src/moonshot-settings.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 182 "/builds/moonshot/ui/src/moonshot-settings.vala"
			g_clear_error (&_inner_error_);
#line 182 "/builds/moonshot/ui/src/moonshot-settings.vala"
			return NULL;
#line 1147 "moonshot-settings.c"
		}
#line 182 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp23_ = _tmp21_;
#line 182 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp21_ = NULL;
#line 182 "/builds/moonshot/ui/src/moonshot-settings.vala"
		result = _tmp23_;
#line 182 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (_tmp21_);
#line 182 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_key_file_unref0 (tmp_key_file);
#line 182 "/builds/moonshot/ui/src/moonshot-settings.vala"
		return result;
#line 1161 "moonshot-settings.c"
	}
	goto __finally26;
	__catch26_g_key_file_error:
	{
		GError* e = NULL;
		MoonshotLogger* _tmp24_;
		MoonshotLogger* _tmp25_;
		GError* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 180 "/builds/moonshot/ui/src/moonshot-settings.vala"
		e = _inner_error_;
#line 180 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_inner_error_ = NULL;
#line 185 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp24_ = logger ();
#line 185 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp25_ = _tmp24_;
#line 185 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp26_ = e;
#line 185 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp27_ = _tmp26_->message;
#line 185 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp28_ = g_strconcat ("get_string_setting got KeyFileError (may be ignorable) : ", _tmp27_, NULL);
#line 185 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp29_ = _tmp28_;
#line 185 "/builds/moonshot/ui/src/moonshot-settings.vala"
		moonshot_logger_info (_tmp25_, _tmp29_, NULL);
#line 185 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_free0 (_tmp29_);
#line 185 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_object_unref0 (_tmp25_);
#line 180 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_error_free0 (e);
#line 1197 "moonshot-settings.c"
	}
	__finally26:
#line 180 "/builds/moonshot/ui/src/moonshot-settings.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 180 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_key_file_unref0 (tmp_key_file);
#line 180 "/builds/moonshot/ui/src/moonshot-settings.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 180 "/builds/moonshot/ui/src/moonshot-settings.vala"
		g_clear_error (&_inner_error_);
#line 180 "/builds/moonshot/ui/src/moonshot-settings.vala"
		return NULL;
#line 1210 "moonshot-settings.c"
	}
#line 187 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp30_ = g_strdup (_default_);
#line 187 "/builds/moonshot/ui/src/moonshot-settings.vala"
	result = _tmp30_;
#line 187 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_g_key_file_unref0 (tmp_key_file);
#line 187 "/builds/moonshot/ui/src/moonshot-settings.vala"
	return result;
#line 1220 "moonshot-settings.c"
}


void
set_string_setting (const gchar* group_name,
                    const gchar* key_name,
                    const gchar* value,
                    GKeyFile* key_file)
{
	GKeyFile* tmp_key_file = NULL;
	GKeyFile* _tmp2_;
#line 190 "/builds/moonshot/ui/src/moonshot-settings.vala"
	g_return_if_fail (group_name != NULL);
#line 190 "/builds/moonshot/ui/src/moonshot-settings.vala"
	g_return_if_fail (key_name != NULL);
#line 190 "/builds/moonshot/ui/src/moonshot-settings.vala"
	g_return_if_fail (value != NULL);
#line 192 "/builds/moonshot/ui/src/moonshot-settings.vala"
	tmp_key_file = NULL;
#line 193 "/builds/moonshot/ui/src/moonshot-settings.vala"
	if (key_file == NULL) {
#line 1242 "moonshot-settings.c"
		GKeyFile* _tmp0_;
		GKeyFile* _tmp1_;
#line 195 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp0_ = get_keyfile ();
#line 195 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_g_key_file_unref0 (tmp_key_file);
#line 195 "/builds/moonshot/ui/src/moonshot-settings.vala"
		tmp_key_file = _tmp0_;
#line 196 "/builds/moonshot/ui/src/moonshot-settings.vala"
		_tmp1_ = tmp_key_file;
#line 196 "/builds/moonshot/ui/src/moonshot-settings.vala"
		key_file = _tmp1_;
#line 1255 "moonshot-settings.c"
	}
#line 199 "/builds/moonshot/ui/src/moonshot-settings.vala"
	g_key_file_set_string (key_file, group_name, key_name, value);
#line 201 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_tmp2_ = tmp_key_file;
#line 201 "/builds/moonshot/ui/src/moonshot-settings.vala"
	if (_tmp2_ != NULL) {
#line 203 "/builds/moonshot/ui/src/moonshot-settings.vala"
		save_keyfile (key_file);
#line 1265 "moonshot-settings.c"
	}
#line 190 "/builds/moonshot/ui/src/moonshot-settings.vala"
	_g_key_file_unref0 (tmp_key_file);
#line 1269 "moonshot-settings.c"
}



