/* moonshot-utils.c generated by valac 0.40.8, the Vala compiler
 * generated from moonshot-utils.vala, do not modify */

/*
 * Copyright (c) 2011-2016, JANET(UK)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of JANET(UK) nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdio.h>
#include <glib/gstdio.h>
#include <gdk/gdk.h>
#include <atk/atk.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>


#define TYPE_ID_CARD (id_card_get_type ())
#define ID_CARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ID_CARD, IdCard))
#define ID_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ID_CARD, IdCardClass))
#define IS_ID_CARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ID_CARD))
#define IS_ID_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ID_CARD))
#define ID_CARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ID_CARD, IdCardClass))

typedef struct _IdCard IdCard;
typedef struct _IdCardClass IdCardClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))


extern gboolean gtk_available;
gboolean gtk_available = FALSE;

GdkPixbuf* find_icon_sized (const gchar* name,
                            GtkIconSize icon_size);
GdkPixbuf* find_icon (const gchar* name,
                      gint size);
GType id_card_get_type (void) G_GNUC_CONST;
GdkPixbuf* get_pixbuf (IdCard* id);
const gchar* GetUserName (void);
const gchar* GetFlatStoreUsersFilePath (void);
gboolean UserForcesFlatFileStore (void);
void make_color (guint16 red,
                 guint16 green,
                 guint16 blue,
                 GdkColor* result);
void set_atk_relation (GtkWidget* widget,
                       GtkWidget* target_widget,
                       AtkRelationType relationship);
GtkWidget* make_ta_fingerprint_widget (const gchar* server_cert,
                                       const gchar* label_text,
                                       gboolean do_colonize,
                                       gint height,
                                       gboolean scrollbar);
gchar* colonize (const gchar* input,
                 gint bytes_per_line);
GtkBox* new_vbox (gint spacing);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
void clear_password_entry (GtkEntry* entry);
void set_bg_color (GtkWidget* w);
GtkBox* new_hbox (gint spacing);


GdkPixbuf*
find_icon_sized (const gchar* name,
                 GtkIconSize icon_size)
{
	GdkPixbuf* result = NULL;
	gint width = 0;
	gint height = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GdkPixbuf* _tmp2_;
#line 40 "/builds/moonshot/ui/src/moonshot-utils.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 43 "/builds/moonshot/ui/src/moonshot-utils.vala"
	gtk_icon_size_lookup (icon_size, &_tmp0_, &_tmp1_);
#line 43 "/builds/moonshot/ui/src/moonshot-utils.vala"
	width = _tmp0_;
#line 43 "/builds/moonshot/ui/src/moonshot-utils.vala"
	height = _tmp1_;
#line 44 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp2_ = find_icon (name, width);
#line 44 "/builds/moonshot/ui/src/moonshot-utils.vala"
	result = _tmp2_;
#line 44 "/builds/moonshot/ui/src/moonshot-utils.vala"
	return result;
#line 128 "moonshot-utils.c"
}


GdkPixbuf*
get_pixbuf (IdCard* id)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_;
#line 54 "/builds/moonshot/ui/src/moonshot-utils.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 56 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp0_ = find_icon ("avatar-default", 48);
#line 56 "/builds/moonshot/ui/src/moonshot-utils.vala"
	result = _tmp0_;
#line 56 "/builds/moonshot/ui/src/moonshot-utils.vala"
	return result;
#line 145 "moonshot-utils.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 77 "/builds/moonshot/ui/src/moonshot-utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 154 "moonshot-utils.c"
}


GdkPixbuf*
find_icon (const gchar* name,
           gint size)
{
	GdkPixbuf* result = NULL;
	gboolean _tmp0_;
	GError * _inner_error_ = NULL;
#line 59 "/builds/moonshot/ui/src/moonshot-utils.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 61 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp0_ = gtk_available;
#line 61 "/builds/moonshot/ui/src/moonshot-utils.vala"
	if (!_tmp0_) {
#line 62 "/builds/moonshot/ui/src/moonshot-utils.vala"
		result = NULL;
#line 62 "/builds/moonshot/ui/src/moonshot-utils.vala"
		return result;
#line 175 "moonshot-utils.c"
	}
	{
		GtkIconTheme* icon_theme = NULL;
		GtkIconTheme* _tmp1_;
		GtkIconTheme* _tmp2_;
		GdkPixbuf* _tmp3_ = NULL;
		GtkIconTheme* _tmp4_;
		GdkPixbuf* _tmp5_;
		GdkPixbuf* _tmp6_;
#line 77 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp1_ = gtk_icon_theme_get_default ();
#line 77 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 77 "/builds/moonshot/ui/src/moonshot-utils.vala"
		icon_theme = _tmp2_;
#line 78 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp4_ = icon_theme;
#line 78 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp5_ = gtk_icon_theme_load_icon (_tmp4_, name, size, GTK_ICON_LOOKUP_FORCE_SIZE, &_inner_error_);
#line 78 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp3_ = _tmp5_;
#line 78 "/builds/moonshot/ui/src/moonshot-utils.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 78 "/builds/moonshot/ui/src/moonshot-utils.vala"
			_g_object_unref0 (icon_theme);
#line 201 "moonshot-utils.c"
			goto __catch29_g_error;
		}
#line 78 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp6_ = _tmp3_;
#line 78 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp3_ = NULL;
#line 78 "/builds/moonshot/ui/src/moonshot-utils.vala"
		result = _tmp6_;
#line 78 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_g_object_unref0 (_tmp3_);
#line 78 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_g_object_unref0 (icon_theme);
#line 78 "/builds/moonshot/ui/src/moonshot-utils.vala"
		return result;
#line 216 "moonshot-utils.c"
	}
	goto __finally29;
	__catch29_g_error:
	{
		GError* e = NULL;
		FILE* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 63 "/builds/moonshot/ui/src/moonshot-utils.vala"
		e = _inner_error_;
#line 63 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_inner_error_ = NULL;
#line 83 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp7_ = stdout;
#line 83 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp8_ = e;
#line 83 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp9_ = _tmp8_->message;
#line 83 "/builds/moonshot/ui/src/moonshot-utils.vala"
		fprintf (_tmp7_, "Error loading icon '%s': %s\n", name, _tmp9_);
#line 84 "/builds/moonshot/ui/src/moonshot-utils.vala"
		result = NULL;
#line 84 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_g_error_free0 (e);
#line 84 "/builds/moonshot/ui/src/moonshot-utils.vala"
		return result;
#line 243 "moonshot-utils.c"
	}
	__finally29:
#line 63 "/builds/moonshot/ui/src/moonshot-utils.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 63 "/builds/moonshot/ui/src/moonshot-utils.vala"
	g_clear_error (&_inner_error_);
#line 63 "/builds/moonshot/ui/src/moonshot-utils.vala"
	return NULL;
#line 252 "moonshot-utils.c"
}


static gchar*
g_file_stream_read_line (FILE* self)
{
	gchar* result = NULL;
	gint c = 0;
	GString* ret = NULL;
	GString* _tmp6_;
#line 3576 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3578 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	ret = NULL;
#line 3579 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	while (TRUE) {
#line 269 "moonshot-utils.c"
		gint _tmp0_;
		GString* _tmp1_;
		gint _tmp3_;
		GString* _tmp4_;
		gint _tmp5_;
#line 3579 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		c = fgetc (self);
#line 3579 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = c;
#line 3579 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (!(_tmp0_ != EOF)) {
#line 3579 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			break;
#line 283 "moonshot-utils.c"
		}
#line 3580 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = ret;
#line 3580 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (_tmp1_ == NULL) {
#line 289 "moonshot-utils.c"
			GString* _tmp2_;
#line 3581 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_tmp2_ = g_string_new ("");
#line 3581 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_g_string_free0 (ret);
#line 3581 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			ret = _tmp2_;
#line 297 "moonshot-utils.c"
		}
#line 3583 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = c;
#line 3583 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (_tmp3_ == ((gint) '\n')) {
#line 3584 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			break;
#line 305 "moonshot-utils.c"
		}
#line 3586 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = ret;
#line 3586 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = c;
#line 3586 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_string_append_c ((GString*) _tmp4_, (gchar) _tmp5_);
#line 313 "moonshot-utils.c"
	}
#line 3588 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp6_ = ret;
#line 3588 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp6_ == NULL) {
#line 3589 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = NULL;
#line 3589 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_string_free0 (ret);
#line 3589 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 325 "moonshot-utils.c"
	} else {
		GString* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 3591 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = ret;
#line 3591 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp8_ = ((GString*) _tmp7_)->str;
#line 3591 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp9_ = g_strdup (_tmp8_);
#line 3591 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = _tmp9_;
#line 3591 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_string_free0 (ret);
#line 3591 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 342 "moonshot-utils.c"
	}
#line 3576 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_g_string_free0 (ret);
#line 346 "moonshot-utils.c"
}


gboolean
UserForcesFlatFileStore (void)
{
	gboolean result = FALSE;
	gchar* username = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* flatstore_users_filename = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	FILE* flatstore_users = NULL;
	const gchar* _tmp4_;
	FILE* _tmp5_;
	FILE* _tmp6_;
	gchar* flatstore_username = NULL;
#line 95 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp0_ = GetUserName ();
#line 95 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 95 "/builds/moonshot/ui/src/moonshot-utils.vala"
	username = _tmp1_;
#line 96 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp2_ = GetFlatStoreUsersFilePath ();
#line 96 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 96 "/builds/moonshot/ui/src/moonshot-utils.vala"
	flatstore_users_filename = _tmp3_;
#line 97 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp4_ = flatstore_users_filename;
#line 97 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp5_ = g_fopen (_tmp4_, "r");
#line 97 "/builds/moonshot/ui/src/moonshot-utils.vala"
	flatstore_users = _tmp5_;
#line 98 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp6_ = flatstore_users;
#line 98 "/builds/moonshot/ui/src/moonshot-utils.vala"
	if (_tmp6_ == NULL) {
#line 99 "/builds/moonshot/ui/src/moonshot-utils.vala"
		result = FALSE;
#line 99 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_fclose0 (flatstore_users);
#line 99 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_g_free0 (flatstore_users_filename);
#line 99 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_g_free0 (username);
#line 99 "/builds/moonshot/ui/src/moonshot-utils.vala"
		return result;
#line 397 "moonshot-utils.c"
	}
#line 101 "/builds/moonshot/ui/src/moonshot-utils.vala"
	flatstore_username = NULL;
#line 102 "/builds/moonshot/ui/src/moonshot-utils.vala"
	while (TRUE) {
#line 403 "moonshot-utils.c"
		FILE* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 102 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp7_ = flatstore_users;
#line 102 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp8_ = g_file_stream_read_line (_tmp7_);
#line 102 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_g_free0 (flatstore_username);
#line 102 "/builds/moonshot/ui/src/moonshot-utils.vala"
		flatstore_username = _tmp8_;
#line 102 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp9_ = flatstore_username;
#line 102 "/builds/moonshot/ui/src/moonshot-utils.vala"
		if (!(_tmp9_ != NULL)) {
#line 102 "/builds/moonshot/ui/src/moonshot-utils.vala"
			break;
#line 423 "moonshot-utils.c"
		}
#line 103 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp10_ = username;
#line 103 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp11_ = flatstore_username;
#line 103 "/builds/moonshot/ui/src/moonshot-utils.vala"
		if (g_strcmp0 (_tmp10_, _tmp11_) == 0) {
#line 104 "/builds/moonshot/ui/src/moonshot-utils.vala"
			result = TRUE;
#line 104 "/builds/moonshot/ui/src/moonshot-utils.vala"
			_g_free0 (flatstore_username);
#line 104 "/builds/moonshot/ui/src/moonshot-utils.vala"
			_fclose0 (flatstore_users);
#line 104 "/builds/moonshot/ui/src/moonshot-utils.vala"
			_g_free0 (flatstore_users_filename);
#line 104 "/builds/moonshot/ui/src/moonshot-utils.vala"
			_g_free0 (username);
#line 104 "/builds/moonshot/ui/src/moonshot-utils.vala"
			return result;
#line 443 "moonshot-utils.c"
		}
	}
#line 107 "/builds/moonshot/ui/src/moonshot-utils.vala"
	result = FALSE;
#line 107 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_g_free0 (flatstore_username);
#line 107 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_fclose0 (flatstore_users);
#line 107 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_g_free0 (flatstore_users_filename);
#line 107 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_g_free0 (username);
#line 107 "/builds/moonshot/ui/src/moonshot-utils.vala"
	return result;
#line 458 "moonshot-utils.c"
}


void
make_color (guint16 red,
            guint16 green,
            guint16 blue,
            GdkColor* result)
{
	GdkColor color = {0};
#line 112 "/builds/moonshot/ui/src/moonshot-utils.vala"
	memset (&color, 0, sizeof (GdkColor));
#line 113 "/builds/moonshot/ui/src/moonshot-utils.vala"
	color.red = red;
#line 114 "/builds/moonshot/ui/src/moonshot-utils.vala"
	color.green = green;
#line 115 "/builds/moonshot/ui/src/moonshot-utils.vala"
	color.blue = blue;
#line 117 "/builds/moonshot/ui/src/moonshot-utils.vala"
	*result = color;
#line 117 "/builds/moonshot/ui/src/moonshot-utils.vala"
	return;
#line 481 "moonshot-utils.c"
}


void
set_atk_relation (GtkWidget* widget,
                  GtkWidget* target_widget,
                  AtkRelationType relationship)
{
	AtkObject* atk_widget = NULL;
	AtkObject* _tmp0_;
	AtkObject* _tmp1_;
	AtkObject* atk_target_widget = NULL;
	AtkObject* _tmp2_;
	AtkObject* _tmp3_;
#line 120 "/builds/moonshot/ui/src/moonshot-utils.vala"
	g_return_if_fail (widget != NULL);
#line 120 "/builds/moonshot/ui/src/moonshot-utils.vala"
	g_return_if_fail (target_widget != NULL);
#line 122 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp0_ = gtk_widget_get_accessible (widget);
#line 122 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 122 "/builds/moonshot/ui/src/moonshot-utils.vala"
	atk_widget = _tmp1_;
#line 123 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp2_ = gtk_widget_get_accessible (target_widget);
#line 123 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 123 "/builds/moonshot/ui/src/moonshot-utils.vala"
	atk_target_widget = _tmp3_;
#line 125 "/builds/moonshot/ui/src/moonshot-utils.vala"
	atk_object_add_relationship (atk_widget, relationship, atk_target_widget);
#line 120 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_g_object_unref0 (atk_target_widget);
#line 120 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_g_object_unref0 (atk_widget);
#line 518 "moonshot-utils.c"
}


static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 158 "/builds/moonshot/ui/src/moonshot-utils.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 527 "moonshot-utils.c"
}


GtkWidget*
make_ta_fingerprint_widget (const gchar* server_cert,
                            const gchar* label_text,
                            gboolean do_colonize,
                            gint height,
                            gboolean scrollbar)
{
	GtkWidget* result = NULL;
	const gchar* _tmp0_ = NULL;
	GtkLabel* fingerprint_label = NULL;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkTextView* fingerprint = NULL;
	GtkTextView* _tmp3_;
	PangoFontDescription* fontdesc = NULL;
	PangoFontDescription* _tmp4_;
	GtkTextView* _tmp5_;
	PangoFontDescription* _tmp6_;
	GtkTextView* _tmp7_;
	GtkTextView* _tmp8_;
	GtkTextBuffer* buffer = NULL;
	GtkTextView* _tmp9_;
	GtkTextBuffer* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextView* _tmp16_;
	GtkLabel* _tmp17_;
	GtkTextView* _tmp18_;
	GtkScrolledWindow* fingerprint_width_constraint = NULL;
	GtkScrolledWindow* _tmp19_;
	GtkScrolledWindow* _tmp21_;
	GtkScrolledWindow* _tmp22_;
	GtkScrolledWindow* _tmp23_;
	GtkTextView* _tmp24_;
	GtkBox* vbox = NULL;
	GtkBox* _tmp25_;
	GtkLabel* _tmp26_;
	GtkScrolledWindow* _tmp27_;
#line 129 "/builds/moonshot/ui/src/moonshot-utils.vala"
	g_return_val_if_fail (server_cert != NULL, NULL);
#line 131 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp0_ = label_text;
#line 131 "/builds/moonshot/ui/src/moonshot-utils.vala"
	if (_tmp0_ == NULL) {
#line 131 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp0_ = _ ("SHA-256 fingerprint:");
#line 576 "moonshot-utils.c"
	}
#line 131 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (_tmp0_);
#line 131 "/builds/moonshot/ui/src/moonshot-utils.vala"
	g_object_ref_sink (_tmp1_);
#line 131 "/builds/moonshot/ui/src/moonshot-utils.vala"
	fingerprint_label = _tmp1_;
#line 132 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp2_ = fingerprint_label;
#line 132 "/builds/moonshot/ui/src/moonshot-utils.vala"
	gtk_misc_set_alignment ((GtkMisc*) _tmp2_, (gfloat) 0, 0.5f);
#line 134 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp3_ = (GtkTextView*) gtk_text_view_new ();
#line 134 "/builds/moonshot/ui/src/moonshot-utils.vala"
	g_object_ref_sink (_tmp3_);
#line 134 "/builds/moonshot/ui/src/moonshot-utils.vala"
	fingerprint = _tmp3_;
#line 135 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp4_ = pango_font_description_from_string ("monospace 10");
#line 135 "/builds/moonshot/ui/src/moonshot-utils.vala"
	fontdesc = _tmp4_;
#line 136 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp5_ = fingerprint;
#line 136 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp6_ = fontdesc;
#line 136 "/builds/moonshot/ui/src/moonshot-utils.vala"
	gtk_widget_modify_font ((GtkWidget*) _tmp5_, _tmp6_);
#line 137 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp7_ = fingerprint;
#line 137 "/builds/moonshot/ui/src/moonshot-utils.vala"
	gtk_text_view_set_editable (_tmp7_, FALSE);
#line 138 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp8_ = fingerprint;
#line 138 "/builds/moonshot/ui/src/moonshot-utils.vala"
	gtk_text_view_set_left_margin (_tmp8_, 3);
#line 139 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp9_ = fingerprint;
#line 139 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp10_ = gtk_text_view_get_buffer (_tmp9_);
#line 139 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 139 "/builds/moonshot/ui/src/moonshot-utils.vala"
	buffer = _tmp11_;
#line 140 "/builds/moonshot/ui/src/moonshot-utils.vala"
	if (do_colonize) {
#line 622 "moonshot-utils.c"
		GtkTextBuffer* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 141 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp12_ = buffer;
#line 141 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp13_ = colonize (server_cert, 16);
#line 141 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp14_ = _tmp13_;
#line 141 "/builds/moonshot/ui/src/moonshot-utils.vala"
		gtk_text_buffer_set_text (_tmp12_, _tmp14_, -1);
#line 141 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_g_free0 (_tmp14_);
#line 636 "moonshot-utils.c"
	} else {
		GtkTextBuffer* _tmp15_;
#line 143 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp15_ = buffer;
#line 143 "/builds/moonshot/ui/src/moonshot-utils.vala"
		gtk_text_buffer_set_text (_tmp15_, server_cert, -1);
#line 643 "moonshot-utils.c"
	}
#line 144 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp16_ = fingerprint;
#line 144 "/builds/moonshot/ui/src/moonshot-utils.vala"
	gtk_text_view_set_wrap_mode (_tmp16_, GTK_WRAP_WORD_CHAR);
#line 146 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp17_ = fingerprint_label;
#line 146 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp18_ = fingerprint;
#line 146 "/builds/moonshot/ui/src/moonshot-utils.vala"
	set_atk_relation ((GtkWidget*) _tmp17_, (GtkWidget*) _tmp18_, ATK_RELATION_LABEL_FOR);
#line 148 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp19_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 148 "/builds/moonshot/ui/src/moonshot-utils.vala"
	g_object_ref_sink (_tmp19_);
#line 148 "/builds/moonshot/ui/src/moonshot-utils.vala"
	fingerprint_width_constraint = _tmp19_;
#line 149 "/builds/moonshot/ui/src/moonshot-utils.vala"
	if (!scrollbar) {
#line 663 "moonshot-utils.c"
		GtkScrolledWindow* _tmp20_;
#line 150 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp20_ = fingerprint_width_constraint;
#line 150 "/builds/moonshot/ui/src/moonshot-utils.vala"
		gtk_scrolled_window_set_policy (_tmp20_, GTK_POLICY_NEVER, GTK_POLICY_NEVER);
#line 669 "moonshot-utils.c"
	}
#line 151 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp21_ = fingerprint_width_constraint;
#line 151 "/builds/moonshot/ui/src/moonshot-utils.vala"
	gtk_scrolled_window_set_shadow_type (_tmp21_, GTK_SHADOW_IN);
#line 152 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp22_ = fingerprint_width_constraint;
#line 152 "/builds/moonshot/ui/src/moonshot-utils.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp22_, 400, height);
#line 153 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp23_ = fingerprint_width_constraint;
#line 153 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp24_ = fingerprint;
#line 153 "/builds/moonshot/ui/src/moonshot-utils.vala"
	gtk_scrolled_window_add_with_viewport (_tmp23_, (GtkWidget*) _tmp24_);
#line 155 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp25_ = new_vbox (0);
#line 155 "/builds/moonshot/ui/src/moonshot-utils.vala"
	vbox = _tmp25_;
#line 156 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp26_ = fingerprint_label;
#line 156 "/builds/moonshot/ui/src/moonshot-utils.vala"
	gtk_box_pack_start (vbox, (GtkWidget*) _tmp26_, TRUE, TRUE, (guint) 2);
#line 157 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp27_ = fingerprint_width_constraint;
#line 157 "/builds/moonshot/ui/src/moonshot-utils.vala"
	gtk_box_pack_start (vbox, (GtkWidget*) _tmp27_, TRUE, TRUE, (guint) 2);
#line 158 "/builds/moonshot/ui/src/moonshot-utils.vala"
	result = (GtkWidget*) vbox;
#line 158 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_g_object_unref0 (fingerprint_width_constraint);
#line 158 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_g_object_unref0 (buffer);
#line 158 "/builds/moonshot/ui/src/moonshot-utils.vala"
	__vala_PangoFontDescription_free0 (fontdesc);
#line 158 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_g_object_unref0 (fingerprint);
#line 158 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_g_object_unref0 (fingerprint_label);
#line 158 "/builds/moonshot/ui/src/moonshot-utils.vala"
	return result;
#line 711 "moonshot-utils.c"
}


static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp8_;
#line 1369 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1370 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1370 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1370 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1371 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 737 "moonshot-utils.c"
		glong _tmp2_;
#line 1372 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = string_length;
#line 1372 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		start = _tmp2_ + start;
#line 743 "moonshot-utils.c"
	}
#line 1374 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 747 "moonshot-utils.c"
		glong _tmp3_;
#line 1375 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1375 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		end = _tmp3_ + end;
#line 753 "moonshot-utils.c"
	}
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 757 "moonshot-utils.c"
		glong _tmp5_;
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = start <= _tmp5_;
#line 763 "moonshot-utils.c"
	} else {
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = FALSE;
#line 767 "moonshot-utils.c"
	}
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp4_, NULL);
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 773 "moonshot-utils.c"
		glong _tmp7_;
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = string_length;
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp6_ = end <= _tmp7_;
#line 779 "moonshot-utils.c"
	} else {
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp6_ = FALSE;
#line 783 "moonshot-utils.c"
	}
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp6_, NULL);
#line 1379 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1380 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp8_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1380 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp8_;
#line 1380 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 795 "moonshot-utils.c"
}


gchar*
colonize (const gchar* input,
          gint bytes_per_line)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gint i = 0;
	gint line_bytes = 0;
#line 162 "/builds/moonshot/ui/src/moonshot-utils.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 163 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp0_ = g_strdup ("");
#line 163 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_result_ = _tmp0_;
#line 164 "/builds/moonshot/ui/src/moonshot-utils.vala"
	i = 0;
#line 165 "/builds/moonshot/ui/src/moonshot-utils.vala"
	line_bytes = 0;
#line 166 "/builds/moonshot/ui/src/moonshot-utils.vala"
	while (TRUE) {
#line 820 "moonshot-utils.c"
		gint _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
#line 166 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp1_ = i;
#line 166 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp2_ = strlen (input);
#line 166 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp3_ = _tmp2_;
#line 166 "/builds/moonshot/ui/src/moonshot-utils.vala"
		if (!(_tmp1_ < _tmp3_)) {
#line 166 "/builds/moonshot/ui/src/moonshot-utils.vala"
			break;
#line 843 "moonshot-utils.c"
		}
#line 167 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp4_ = line_bytes;
#line 167 "/builds/moonshot/ui/src/moonshot-utils.vala"
		if (_tmp4_ == bytes_per_line) {
#line 849 "moonshot-utils.c"
			const gchar* _tmp5_;
			gchar* _tmp6_;
#line 168 "/builds/moonshot/ui/src/moonshot-utils.vala"
			_tmp5_ = _result_;
#line 168 "/builds/moonshot/ui/src/moonshot-utils.vala"
			_tmp6_ = g_strconcat (_tmp5_, "\n", NULL);
#line 168 "/builds/moonshot/ui/src/moonshot-utils.vala"
			_g_free0 (_result_);
#line 168 "/builds/moonshot/ui/src/moonshot-utils.vala"
			_result_ = _tmp6_;
#line 169 "/builds/moonshot/ui/src/moonshot-utils.vala"
			line_bytes = 0;
#line 862 "moonshot-utils.c"
		} else {
			gint _tmp7_;
#line 171 "/builds/moonshot/ui/src/moonshot-utils.vala"
			_tmp7_ = i;
#line 171 "/builds/moonshot/ui/src/moonshot-utils.vala"
			if (_tmp7_ > 0) {
#line 869 "moonshot-utils.c"
				const gchar* _tmp8_;
				gchar* _tmp9_;
#line 172 "/builds/moonshot/ui/src/moonshot-utils.vala"
				_tmp8_ = _result_;
#line 172 "/builds/moonshot/ui/src/moonshot-utils.vala"
				_tmp9_ = g_strconcat (_tmp8_, ":", NULL);
#line 172 "/builds/moonshot/ui/src/moonshot-utils.vala"
				_g_free0 (_result_);
#line 172 "/builds/moonshot/ui/src/moonshot-utils.vala"
				_result_ = _tmp9_;
#line 880 "moonshot-utils.c"
			}
		}
#line 174 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp10_ = _result_;
#line 174 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp11_ = i;
#line 174 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp12_ = i;
#line 174 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp13_ = string_slice (input, (glong) _tmp11_, (glong) (_tmp12_ + 2));
#line 174 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp14_ = _tmp13_;
#line 174 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp15_ = g_strconcat (_tmp10_, _tmp14_, NULL);
#line 174 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_g_free0 (_result_);
#line 174 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_result_ = _tmp15_;
#line 174 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_g_free0 (_tmp14_);
#line 175 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp16_ = i;
#line 175 "/builds/moonshot/ui/src/moonshot-utils.vala"
		i = _tmp16_ + 2;
#line 176 "/builds/moonshot/ui/src/moonshot-utils.vala"
		_tmp17_ = line_bytes;
#line 176 "/builds/moonshot/ui/src/moonshot-utils.vala"
		line_bytes = _tmp17_ + 1;
#line 909 "moonshot-utils.c"
	}
#line 178 "/builds/moonshot/ui/src/moonshot-utils.vala"
	result = _result_;
#line 178 "/builds/moonshot/ui/src/moonshot-utils.vala"
	return result;
#line 915 "moonshot-utils.c"
}


static guint8*
string_get_data (const gchar* self,
                 int* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
#line 1442 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1443 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	res = (guint8*) self;
#line 1443 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	res_length1 = -1;
#line 1443 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1444 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1444 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1444 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1444 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp2_ = res_length1;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp3_ = res;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp3__length1 = res_length1;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp4__length1 = _tmp3__length1;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (result_length1) {
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 962 "moonshot-utils.c"
	}
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 1445 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 968 "moonshot-utils.c"
}


void
clear_password_entry (GtkEntry* entry)
{
	gint len = 0;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* random_chars = NULL;
	gint _tmp3_;
	gchar* _tmp4_;
	gint random_chars_length1;
	gint _random_chars_size_;
	gchar* _tmp12_;
	gint _tmp12__length1;
	gint _tmp13_;
	gchar _tmp14_;
	gchar* r = NULL;
	gchar* _tmp15_;
	gint _tmp15__length1;
	gchar* _tmp16_;
	GtkEntryBuffer* buf = NULL;
	GtkEntryBuffer* _tmp17_;
	GtkEntryBuffer* _tmp18_;
	guint8* _tmp19_;
	gint _tmp19__length1;
	guint8* _tmp20_;
	gint _tmp20__length1;
	gint _tmp21_;
#line 181 "/builds/moonshot/ui/src/moonshot-utils.vala"
	g_return_if_fail (entry != NULL);
#line 184 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp0_ = gtk_entry_get_text (entry);
#line 184 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp1_ = strlen (_tmp0_);
#line 184 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp2_ = _tmp1_;
#line 184 "/builds/moonshot/ui/src/moonshot-utils.vala"
	len = _tmp2_;
#line 185 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp3_ = len;
#line 185 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp4_ = g_new0 (gchar, _tmp3_ + 1);
#line 185 "/builds/moonshot/ui/src/moonshot-utils.vala"
	random_chars = _tmp4_;
#line 185 "/builds/moonshot/ui/src/moonshot-utils.vala"
	random_chars_length1 = _tmp3_ + 1;
#line 185 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_random_chars_size_ = random_chars_length1;
#line 1020 "moonshot-utils.c"
	{
		gint i = 0;
#line 186 "/builds/moonshot/ui/src/moonshot-utils.vala"
		i = 0;
#line 1025 "moonshot-utils.c"
		{
			gboolean _tmp5_ = FALSE;
#line 186 "/builds/moonshot/ui/src/moonshot-utils.vala"
			_tmp5_ = TRUE;
#line 186 "/builds/moonshot/ui/src/moonshot-utils.vala"
			while (TRUE) {
#line 1032 "moonshot-utils.c"
				gint _tmp7_;
				gint _tmp8_;
				gchar* _tmp9_;
				gint _tmp9__length1;
				gint _tmp10_;
				gchar _tmp11_;
#line 186 "/builds/moonshot/ui/src/moonshot-utils.vala"
				if (!_tmp5_) {
#line 1041 "moonshot-utils.c"
					gint _tmp6_;
#line 186 "/builds/moonshot/ui/src/moonshot-utils.vala"
					_tmp6_ = i;
#line 186 "/builds/moonshot/ui/src/moonshot-utils.vala"
					i = _tmp6_ + 1;
#line 1047 "moonshot-utils.c"
				}
#line 186 "/builds/moonshot/ui/src/moonshot-utils.vala"
				_tmp5_ = FALSE;
#line 186 "/builds/moonshot/ui/src/moonshot-utils.vala"
				_tmp7_ = i;
#line 186 "/builds/moonshot/ui/src/moonshot-utils.vala"
				_tmp8_ = len;
#line 186 "/builds/moonshot/ui/src/moonshot-utils.vala"
				if (!(_tmp7_ < _tmp8_)) {
#line 186 "/builds/moonshot/ui/src/moonshot-utils.vala"
					break;
#line 1059 "moonshot-utils.c"
				}
#line 187 "/builds/moonshot/ui/src/moonshot-utils.vala"
				_tmp9_ = random_chars;
#line 187 "/builds/moonshot/ui/src/moonshot-utils.vala"
				_tmp9__length1 = random_chars_length1;
#line 187 "/builds/moonshot/ui/src/moonshot-utils.vala"
				_tmp10_ = i;
#line 187 "/builds/moonshot/ui/src/moonshot-utils.vala"
				_tmp9_[_tmp10_] = (gchar) g_random_int_range ((gint32) 40, (gint32) 127);
#line 187 "/builds/moonshot/ui/src/moonshot-utils.vala"
				_tmp11_ = _tmp9_[_tmp10_];
#line 1071 "moonshot-utils.c"
			}
		}
	}
#line 189 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp12_ = random_chars;
#line 189 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp12__length1 = random_chars_length1;
#line 189 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp13_ = len;
#line 189 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp12_[_tmp13_] = (gchar) 0;
#line 189 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp14_ = _tmp12_[_tmp13_];
#line 190 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp15_ = random_chars;
#line 190 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp15__length1 = random_chars_length1;
#line 190 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp16_ = g_strdup ((const gchar*) _tmp15_);
#line 190 "/builds/moonshot/ui/src/moonshot-utils.vala"
	r = _tmp16_;
#line 191 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp17_ = gtk_entry_get_buffer (entry);
#line 191 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp18_ = _g_object_ref0 (_tmp17_);
#line 191 "/builds/moonshot/ui/src/moonshot-utils.vala"
	buf = _tmp18_;
#line 194 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp19_ = string_get_data (r, &_tmp19__length1);
#line 194 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp20_ = _tmp19_;
#line 194 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp20__length1 = _tmp19__length1;
#line 194 "/builds/moonshot/ui/src/moonshot-utils.vala"
	gtk_entry_buffer_set_text (buf, (const gchar*) _tmp20_, _tmp20__length1);
#line 197 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp21_ = len;
#line 197 "/builds/moonshot/ui/src/moonshot-utils.vala"
	gtk_entry_buffer_delete_text (buf, (guint) 0, (guint) _tmp21_);
#line 181 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_g_object_unref0 (buf);
#line 181 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_g_free0 (r);
#line 181 "/builds/moonshot/ui/src/moonshot-utils.vala"
	random_chars = (g_free (random_chars), NULL);
#line 1117 "moonshot-utils.c"
}


void
set_bg_color (GtkWidget* w)
{
#line 208 "/builds/moonshot/ui/src/moonshot-utils.vala"
	g_return_if_fail (w != NULL);
#line 1126 "moonshot-utils.c"
}


GtkBox*
new_vbox (gint spacing)
{
	GtkBox* result = NULL;
	GtkVBox* _tmp0_;
#line 224 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp0_ = (GtkVBox*) gtk_vbox_new (FALSE, spacing);
#line 224 "/builds/moonshot/ui/src/moonshot-utils.vala"
	g_object_ref_sink (_tmp0_);
#line 224 "/builds/moonshot/ui/src/moonshot-utils.vala"
	result = (GtkBox*) _tmp0_;
#line 224 "/builds/moonshot/ui/src/moonshot-utils.vala"
	return result;
#line 1143 "moonshot-utils.c"
}


GtkBox*
new_hbox (gint spacing)
{
	GtkBox* result = NULL;
	GtkHBox* _tmp0_;
#line 229 "/builds/moonshot/ui/src/moonshot-utils.vala"
	_tmp0_ = (GtkHBox*) gtk_hbox_new (FALSE, spacing);
#line 229 "/builds/moonshot/ui/src/moonshot-utils.vala"
	g_object_ref_sink (_tmp0_);
#line 229 "/builds/moonshot/ui/src/moonshot-utils.vala"
	result = (GtkBox*) _tmp0_;
#line 229 "/builds/moonshot/ui/src/moonshot-utils.vala"
	return result;
#line 1160 "moonshot-utils.c"
}



